/* 
 * Copyright (c) 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: std.gi,v 1.5 2002/02/26 13:05:27 malekith Exp $
 *
 * Runtime environment for Gont, Std module interface.
 * 
 * This module is opened at the beginning of every compilation unit.
 */

string itoa(int);
int atoi(string);

string ftoa(float);
float atof(string);

void print_string(string);
void print_int(int);
void print_float(float);
void print_endline(string);
void print_newline();

void prerr_string(string);
void prerr_int(int);
void prerr_float(float);
void prerr_endline(string);
void prerr_newline();

string read_line();
int read_int();
float read_float();

union <'a>option {
	void None;
	'a Some;
}

bool streq(string, string);
int strcmp(string, string);
string strjoin(string, string);

'a fst(*['a, 'b]);
'b snd(*['a, 'b]);

exception void Match_failure
exception void Null_access
exception string Invalid_argument
exception string Failure
exception void Not_found
exception void Exit
exception void End_of_file

'a invalid_argument(string);
'a fail_with(string);
'a exit(int);
void at_exit(*() -> void);

